#include "googlemapmodel.h"
#include <QDebug>
#include <QModelIndex>
GoogleMapModel::GoogleMapModel(QObject *parent) :
        QAbstractListModel(parent)
{


    mHttp = new QHttp;
    connect(mHttp,SIGNAL(done(bool)),this,SLOT(parseResult(bool)));
}

int GoogleMapModel::rowCount(const QModelIndex &parent) const
{
    return mAddressList.count();
}


QVariant GoogleMapModel::data(const QModelIndex &index, int role) const
{


    if (!index.isValid())
        return QVariant();

    if (index.row() >= mAddressList.size())
        return QVariant();

//    if (role == Qt::EditRole)
//        return mAddressList.at(index.row());

    if (role == Qt::DisplayRole)
        return mAddressList.at(index.row());
    else
        return QVariant();
}

void GoogleMapModel::search(QString search)
{
    QString condition = search.replace(" ","+");
    mHttp->setHost("maps.google.com");
    mHttp->get("/maps/geo?q="+condition+"&output=xml&sensor=true&key="+GOOGLE_KEY);



}

void GoogleMapModel::parseResult(bool error)
{

mAddressList.clear();


    QDomDocument document;
    document.setContent(mHttp->readAll());



    QDomElement docElem = document.documentElement();

    QDomNode n = docElem.firstChild().firstChild(); //Response => PlaceMark

    while(!n.isNull()) {

        if (n.nodeName() == "Placemark" )
         mAddressList <<  n.toElement().firstChildElement().text();




        n = n.nextSibling();
    }

qDebug()<<mAddressList;
    emit dataChanged(index(0),index(mAddressList.count()));
    emit done();
//    emit layoutAboutToBeChanged();
//    emit layoutChanged();
}
